Index: src/UIElements/TextUI/TextDialog.cpp
===================================================================
--- src/UIElements/TextUI/TextDialog.cpp	(revision 6940bb556236165ebf89b8495b117042efebb708)
+++ src/UIElements/TextUI/TextDialog.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -20,26 +20,5 @@
 #include "Helpers/MemDebug.hpp"
 
-#include <iostream>
-
-#include <Descriptors/AtomDescriptor.hpp>
-#include <Descriptors/AtomIdDescriptor.hpp>
-#include <Descriptors/MoleculeDescriptor.hpp>
-#include <Descriptors/MoleculeIdDescriptor.hpp>
-#include <boost/lexical_cast.hpp>
 #include "TextUI/TextDialog.hpp"
-
-#include "World.hpp"
-#include "periodentafel.hpp"
-#include "Helpers/Log.hpp"
-#include "Helpers/Verbose.hpp"
-
-#include "atom.hpp"
-#include "element.hpp"
-#include "molecule.hpp"
-#include "LinearAlgebra/Vector.hpp"
-#include "LinearAlgebra/Matrix.hpp"
-#include "Box.hpp"
-
-#include <boost/lexical_cast.hpp>
 
 using namespace std;
@@ -125,561 +104,10 @@
 }
 
-/************************** Query Infrastructure ************************/
-
-TextDialog::EmptyTextQuery::EmptyTextQuery(string title, std::string _description) :
-    Dialog::EmptyQuery(title,_description)
-{}
-
-TextDialog::EmptyTextQuery::~EmptyTextQuery() {}
-
-bool TextDialog::EmptyTextQuery::handle() {
-  cout << "Message of " << getTitle() << ":\n" << getDescription() << "\n";
-  return true;
+void TextDialog::queryFile(const char* title, std::string description){
+  registerQuery(new FileTextQuery(title,description));
 }
 
-TextDialog::IntTextQuery::IntTextQuery(string title, std::string _description) :
-    Dialog::IntQuery(title,_description)
-{}
+/************************** Query Infrastructure ************************/
+/*       ---> shifted to folder Query                                   */
+/************************************************************************/
 
-TextDialog::IntTextQuery::~IntTextQuery() {}
-
-bool TextDialog::IntTextQuery::handle() {
-  bool badInput = false;
-  do{
-    badInput = false;
-    Log() << Verbose(0) << getTitle();
-    cin >> tmp;
-    if(cin.fail()){
-      badInput=true;
-      cin.clear();
-      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
-      Log() << Verbose(0) << "Input was not a number!" << endl;
-    }
-  } while(badInput);
-  // clear the input buffer of anything still in the line
-  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
-  return true;
-}
-
-TextDialog::IntsTextQuery::IntsTextQuery(string title, std::string _description) :
-    Dialog::IntsQuery(title,_description)
-{}
-
-TextDialog::IntsTextQuery::~IntsTextQuery() {}
-
-bool TextDialog::IntsTextQuery::handle() {
-  Log() << Verbose(0) << getTitle();
-  std::string line;
-  getline(cin,line);
-  // dissect by " "
-  std::string::iterator olditer = line.begin();
-  for(string::iterator iter = line.begin(); iter != line.end(); ++iter) {
-    if (*iter == ' ') {
-      std::istringstream stream(string(iter, olditer));
-      stream >> temp;
-      tmp.push_back(temp);
-      olditer = iter;
-    }
-  }
-  if (olditer != line.begin()) { // insert last part also
-    std::istringstream stream(string(olditer, line.end()));
-    stream >> temp;
-    tmp.push_back(temp);
-  }
-
-  return true;
-}
-
-TextDialog::BooleanTextQuery::BooleanTextQuery(string title, std::string _description) :
-    Dialog::BooleanQuery(title,_description)
-{}
-
-TextDialog::BooleanTextQuery::~BooleanTextQuery() {}
-
-bool TextDialog::BooleanTextQuery::handle() {
-  bool badInput = false;
-  char input = ' ';
-  do{
-    badInput = false;
-    Log() << Verbose(0) << getTitle();
-    cin >> input;
-    if ((input == 'y' ) || (input == 'Y')) {
-      tmp = true;
-    } else if ((input == 'n' ) || (input == 'N')) {
-      tmp = false;
-    } else {
-      badInput=true;
-      cin.clear();
-      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
-      Log() << Verbose(0) << "Input was not of [yYnN]!" << endl;
-    }
-  } while(badInput);
-  // clear the input buffer of anything still in the line
-  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
-  return true;
-}
-
-TextDialog::StringTextQuery::StringTextQuery(string title, std::string _description) :
-    Dialog::StringQuery(title,_description)
-{}
-
-TextDialog::StringTextQuery::~StringTextQuery() {}
-
-bool TextDialog::StringTextQuery::handle() {
-  Log() << Verbose(0) << getTitle();
-  getline(cin,tmp);
-  return true;
-}
-
-TextDialog::StringsTextQuery::StringsTextQuery(string title, std::string _description) :
-    Dialog::StringsQuery(title,_description)
-{}
-
-TextDialog::StringsTextQuery::~StringsTextQuery() {}
-
-bool TextDialog::StringsTextQuery::handle() {
-  Log() << Verbose(0) << getTitle();
-  getline(cin,temp);
-  // dissect by " "
-  std::string::iterator olditer = temp.begin();
-  for(string::iterator iter = temp.begin(); iter != temp.end(); ++iter) {
-    if (*iter == ' ') {
-      tmp.push_back(string(iter, olditer));
-      olditer = iter;
-    }
-  }
-  if (olditer != temp.begin())  // insert last part also
-    tmp.push_back(string(olditer, temp.end()));
-
-  return true;
-}
-
-TextDialog::DoubleTextQuery::DoubleTextQuery(string title, std::string _description) :
-    Dialog::DoubleQuery(title,_description)
-{}
-
-TextDialog::DoubleTextQuery::~DoubleTextQuery() {}
-
-bool TextDialog::DoubleTextQuery::handle() {
-  bool badInput = false;
-  do{
-    badInput = false;
-    Log() << Verbose(0) << getTitle();
-    cin >> tmp;
-    if(cin.fail()){
-      badInput = true;
-      cin.clear();
-      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
-      Log() << Verbose(0) << "Input was not a number!" << endl;
-    }
-  }while(badInput);
-  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
-  return true;
-}
-
-
-TextDialog::DoublesTextQuery::DoublesTextQuery(string title, std::string _description) :
-    Dialog::DoublesQuery(title,_description)
-{}
-
-TextDialog::DoublesTextQuery::~DoublesTextQuery() {}
-
-bool TextDialog::DoublesTextQuery::handle() {
-  Log() << Verbose(0) << getTitle();
-  std::string line;
-  getline(cin,line);
-  // dissect by " "
-  std::string::iterator olditer = line.begin();
-  for(string::iterator iter = line.begin(); iter != line.end(); ++iter) {
-    if (*iter == ' ') {
-      std::istringstream stream(string(iter, olditer));
-      stream >> temp;
-      tmp.push_back(temp);
-      olditer = iter;
-    }
-  }
-  if (olditer != line.begin()) { // insert last part also
-    std::istringstream stream(string(olditer, line.end()));
-    stream >> temp;
-    tmp.push_back(temp);
-  }
-
-  return true;
-}
-
-TextDialog::AtomTextQuery::AtomTextQuery(string title, std::string _description) :
-    Dialog::AtomQuery(title,_description)
-{}
-
-TextDialog::AtomTextQuery::~AtomTextQuery() {}
-
-bool TextDialog::AtomTextQuery::handle() {
-  int idxOfAtom=-1;
-  bool badInput = false;
-  do{
-    badInput = false;
-    Log() << Verbose(0) << getTitle();
-    cin >> idxOfAtom;
-    if(cin.fail()){
-      badInput = true;
-      cin.clear();
-      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
-      Log() << Verbose(0) << "Input was not a number!" << endl;
-      continue;
-    }
-
-    tmp = World::getInstance().getAtom(AtomById(idxOfAtom));
-    if(!tmp && idxOfAtom!=-1){
-      Log() << Verbose(0) << "Invalid Atom Index" << idxOfAtom << endl;
-      badInput = true;
-    }
-
-  } while(badInput);
-  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
-  return (idxOfAtom!=-1);
-}
-
-
-TextDialog::AtomsTextQuery::AtomsTextQuery(string title, std::string _description) :
-    Dialog::AtomsQuery(title,_description)
-{}
-
-TextDialog::AtomsTextQuery::~AtomsTextQuery() {}
-
-bool TextDialog::AtomsTextQuery::handle() {
-  int idxOfAtom=-1;
-  Log() << Verbose(0) << getTitle();
-  std::string line;
-  getline(cin,line);
-  // dissect by " "
-  std::string::iterator olditer = line.begin();
-  for(string::iterator iter = line.begin(); iter != line.end(); ++iter) {
-    if (*iter == ' ') {
-      std::istringstream stream(string(iter, olditer));
-      stream >> idxOfAtom;
-      temp = World::getInstance().getAtom(AtomById(idxOfAtom));
-      if(!temp && idxOfAtom!=-1){
-        Log() << Verbose(0) << "Invalid Atom Index" << idxOfAtom << endl;
-        break;
-      }
-      tmp.push_back(temp);
-      olditer = iter;
-    }
-  }
-  if (olditer != line.begin()) { // insert last part also
-    std::istringstream stream(string(olditer, line.end()));
-    stream >> idxOfAtom;
-    temp = World::getInstance().getAtom(AtomById(idxOfAtom));
-    if(!temp && idxOfAtom!=-1) {
-      Log() << Verbose(0) << "Invalid Atom Index" << idxOfAtom << endl;
-      tmp.push_back(temp);
-    }
-  }
-
-  return (idxOfAtom!=-1);
-}
-
-TextDialog::MoleculeTextQuery::MoleculeTextQuery(string title, std::string _description) :
-    Dialog::MoleculeQuery(title,_description)
-{}
-
-TextDialog::MoleculeTextQuery::~MoleculeTextQuery() {}
-
-bool TextDialog::MoleculeTextQuery::handle() {
-  int idxOfMol=0;
-  bool badInput = false;
-  do{
-    badInput = false;
-    Log() << Verbose(0) << getTitle();
-    cin >> idxOfMol;
-    if(cin.fail()){
-      badInput = true;
-      cin.clear();
-      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
-      Log() << Verbose(0) << "Input was not a number!" << endl;
-      continue;
-    }
-
-    tmp = World::getInstance().getMolecule(MoleculeById(idxOfMol));
-    if(!tmp && idxOfMol!=-1){
-      Log() << Verbose(0) << "Invalid Molecule Index" << endl;
-      badInput = true;
-    }
-
-  } while(badInput);
-  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
-  return (idxOfMol!=-1);
-}
-
-
-TextDialog::MoleculesTextQuery::MoleculesTextQuery(string title, std::string _description) :
-    Dialog::MoleculesQuery(title,_description)
-{}
-
-TextDialog::MoleculesTextQuery::~MoleculesTextQuery() {}
-
-bool TextDialog::MoleculesTextQuery::handle() {
-  int idxOfMol=-1;
-  Log() << Verbose(0) << getTitle();
-  std::string line;
-  getline(cin,line);
-  // dissect by " "
-  std::string::iterator olditer = line.begin();
-  for(string::iterator iter = line.begin(); iter != line.end(); ++iter) {
-    if (*iter == ' ') {
-      std::istringstream stream(string(iter, olditer));
-      stream >> idxOfMol;
-      temp = World::getInstance().getMolecule(MoleculeById(idxOfMol));
-      if(!temp && idxOfMol!=-1){
-        Log() << Verbose(0) << "Invalid Molecule Index" << idxOfMol << endl;
-        break;
-      }
-      tmp.push_back(temp);
-      olditer = iter;
-    }
-  }
-  if (olditer != line.begin()) { // insert last part also
-    std::istringstream stream(string(olditer, line.end()));
-    stream >> idxOfMol;
-    temp = World::getInstance().getMolecule(MoleculeById(idxOfMol));
-    if(!temp && idxOfMol!=-1){
-      Log() << Verbose(0) << "Invalid Molecule Index" << idxOfMol << endl;
-      tmp.push_back(temp);
-    }
-  }
-
-  return (idxOfMol!=-1);
-}
-
-TextDialog::VectorTextQuery::VectorTextQuery(std::string title, bool _check, std::string _description) :
-    Dialog::VectorQuery(title,_check,_description)
-{}
-
-TextDialog::VectorTextQuery::~VectorTextQuery()
-{}
-
-bool TextDialog::VectorTextQuery::handle() {
-  std::cout << getTitle();
-  const Matrix &M = World::getInstance().getDomain().getM();
-  char coords[3] = {'x', 'y', 'z'};
-  for (int i=0;i<3;i++)
-    std::cout << coords[i] << "[0.." << M.at(i,i) << ( (i!=2) ? "], " : "]: ");
-
-  std::string line;
-  getline(cin,line);
-
-  // dissect by ","
-  double coord = 0.;
-  int counter = 0;
-  std::string::iterator olditer = line.begin();
-  for(string::iterator iter = line.begin(); (iter != line.end()) && (counter != 3); ++iter) {
-    if (*iter == ',') {
-      std::istringstream stream(string(iter, olditer));
-      stream >> coord;
-      tmp[counter++] = coord;
-      olditer = iter;
-    }
-  }
-  if ((olditer != line.begin()) && (counter != 3)) { // insert last part also
-    std::istringstream stream(string(olditer, line.end()));
-    stream >> coord;
-    tmp[counter++] = coord;
-  }
-
-  // check vector
-  return World::getInstance().getDomain().isInside(tmp);
-}
-
-TextDialog::VectorsTextQuery::VectorsTextQuery(std::string title, bool _check, std::string _description) :
-    Dialog::VectorsQuery(title,_check,_description)
-{}
-
-TextDialog::VectorsTextQuery::~VectorsTextQuery()
-{}
-
-bool TextDialog::VectorsTextQuery::handle() {
-  std::cout << getTitle();
-  char coords[3] = {'x', 'y', 'z'};
-  const Matrix &M = World::getInstance().getDomain().getM();
-  for (int i=0;i<3;i++)
-    std::cout << coords[i] << "[0.." << M.at(i,i) << ( (i!=2) ? "], " : "]: ");
-
-  std::string line;
-  getline(cin,line);
-
-  // dissect by ","
-  double coord = 0.;
-  std::string::iterator olditerspace = line.begin();
-  std::string::iterator olditercomma = line.begin();
-  int counter = 0;
-  for(string::iterator vectoriter = line.begin(); vectoriter != line.end(); ++vectoriter) {
-    if (*vectoriter == ',')
-      counter++;
-    if ((*vectoriter == ' ') && (counter == 2)) {
-      counter = 0;
-      for(string::iterator componentiter = olditerspace; (componentiter != vectoriter) && (counter !=3); ++componentiter) {
-        if (*componentiter == ',') {
-          std::istringstream stream(string(componentiter, olditercomma));
-          stream >> coord;
-          temp[counter++] = coord;
-          olditercomma = componentiter;
-        }
-      }
-      if ((olditercomma != line.begin()) && (counter != 3)) { // insert last part also
-        std::istringstream stream(string(olditercomma, vectoriter));
-        stream >> coord;
-        temp[counter++] = coord;
-      }
-      if (World::getInstance().getDomain().isInside(temp))
-        tmp.push_back(temp);
-      olditerspace = vectoriter;
-    }
-  }
-
-  return true;
-}
-
-TextDialog::BoxTextQuery::BoxTextQuery(std::string title, std::string _description) :
-    Dialog::BoxQuery(title,_description)
-{}
-
-TextDialog::BoxTextQuery::~BoxTextQuery()
-{}
-
-bool TextDialog::BoxTextQuery::handle() {
-  Log() << Verbose(0) << getTitle();
-
-  double temp[6];
-  std::string coords[6] = {"xx","yx","yy", "zx", "zy", "zz"};
-  for (int i=0;i<6;i++) {
-    Log() << Verbose(0) << coords[i] << ": ";
-    cin >> temp[i];
-  }
-  Matrix M;
-  M.set(0,0, temp[0]);
-  M.set(0,1, temp[1]);
-  M.set(0,2, temp[2]);
-  M.set(1,0, temp[1]);
-  M.set(1,1, temp[3]);
-  M.set(1,2, temp[4]);
-  M.set(2,0, temp[2]);
-  M.set(2,1, temp[4]);
-  M.set(2,2, temp[5]);
-  tmp.setM(M);
-  return true;
-}
-
-TextDialog::ElementTextQuery::ElementTextQuery(std::string title, std::string _description) :
-    Dialog::ElementQuery(title,_description)
-{}
-
-TextDialog::ElementTextQuery::~ElementTextQuery()
-{}
-
-bool TextDialog::ElementTextQuery::handle() {
-  bool badInput=false;
-  bool aborted = false;
-  const element * temp = NULL;
-  do{
-    badInput = false;
-    Log() << Verbose(0) << getTitle();
-
-    // try to read as Atomic number
-    int Z;
-    cin >> Z;
-    if(!cin.fail()){
-      if(Z==-1){
-        aborted = true;
-      }
-      else{
-        temp = World::getInstance().getPeriode()->FindElement(Z);
-        if(!temp){
-          Log() << Verbose(0) << "No element with this atomic number!" << endl;
-          badInput = true;
-        }
-      }
-      continue;
-    }
-    else{
-      cin.clear();
-    }
-
-    // Try to read as shorthand
-    // the last buffer content was not removed, so we read the
-    // same thing again, this time as a std::string
-    std::string shorthand;
-    cin >> shorthand;
-    if(!cin.fail()){
-      if(shorthand.empty()){
-        aborted = true;
-      }
-      else{
-        temp = World::getInstance().getPeriode()->FindElement(shorthand.c_str());
-        if(!temp){
-          Log() << Verbose(0) << "No element with this shorthand!" << endl;
-          badInput = true;
-        }
-      }
-    }
-    else{
-      Log() << Verbose(0) << "Could not read input. Try Again." << endl;
-      cin.clear();
-      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
-      badInput = true;
-    }
-
-  }while(badInput);
-  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
-  return !aborted;
-}
-
-TextDialog::ElementsTextQuery::ElementsTextQuery(std::string title, std::string _description) :
-    Dialog::ElementsQuery(title,_description)
-{}
-
-TextDialog::ElementsTextQuery::~ElementsTextQuery()
-{}
-
-bool TextDialog::ElementsTextQuery::handle() {
-  std::string shorthand;
-  int Z=-1;
-  Log() << Verbose(0) << getTitle();
-  std::string line;
-  getline(cin,line);
-  // dissect by " "
-  std::string::iterator olditer = line.begin();
-  for(string::iterator iter = line.begin(); iter != line.end(); ++iter) {
-    if (*iter == ' ') {
-      std::istringstream stream(string(iter, olditer));
-      stream >> shorthand;
-      try {
-        Z = lexical_cast<int>(shorthand);
-        temp = World::getInstance().getPeriode()->FindElement(Z);
-      } catch (bad_lexical_cast) {
-        temp = World::getInstance().getPeriode()->FindElement(shorthand.c_str());
-      };
-      if(!temp && Z!=-1){
-        Log() << Verbose(0) << "Invalid Element" << shorthand << endl;
-        break;
-      }
-      tmp.push_back(temp);
-      olditer = iter;
-    }
-  }
-  if (olditer != line.begin()) { // insert last part also
-    std::istringstream stream(string(olditer, line.end()));
-    stream >> shorthand;
-    try {
-      Z = lexical_cast<int>(shorthand);
-      temp = World::getInstance().getPeriode()->FindElement(Z);
-    } catch (bad_lexical_cast) {
-      temp = World::getInstance().getPeriode()->FindElement(shorthand.c_str());
-    };
-    if(!temp && Z!=-1) {
-      Log() << Verbose(0) << "Invalid Element" << shorthand << endl;
-      tmp.push_back(temp);
-    }
-  }
-
-  return (Z!=-1);
-}
Index: src/UIElements/TextUI/TextDialog.hpp
===================================================================
--- src/UIElements/TextUI/TextDialog.hpp	(revision 6940bb556236165ebf89b8495b117042efebb708)
+++ src/UIElements/TextUI/TextDialog.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -41,4 +41,5 @@
   virtual void queryElement(const char*, std::string = "");
   virtual void queryElements(const char*, std::string = "");
+  virtual void queryFile(const char*, std::string = "");
 
 protected:
@@ -162,4 +163,11 @@
     virtual bool handle();
   };
+
+  class FileTextQuery : public Dialog::FileQuery {
+  public:
+    FileTextQuery(std::string title, std::string _description = NULL);
+    virtual ~FileTextQuery();
+    virtual bool handle();
+  };
 };
 
Index: src/UIElements/Views/Qt4/GLMoleculeView.cpp
===================================================================
--- src/UIElements/Views/Qt4/GLMoleculeView.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/Views/Qt4/GLMoleculeView.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,29 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * GLMoleculeView.cpp
+ *
+ *  Created on: Jan 26, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "GLMoleculeView.hpp"
+
+#include "Helpers/MemDebug.hpp"
+
+GLMoleculeView::GLMoleculeView(QWidget *parent) :
+  QGLWidget(parent)
+{}
+
+GLMoleculeView::~GLMoleculeView()
+{}
Index: src/UIElements/Views/Qt4/GLMoleculeView.hpp
===================================================================
--- src/UIElements/Views/Qt4/GLMoleculeView.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/Views/Qt4/GLMoleculeView.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,21 @@
+/*
+ * GLMoleculeView.hpp
+ *
+ *  Created on: Jan 26, 2010
+ *      Author: crueger
+ */
+
+#ifndef GLMOLECULEVIEW_HPP_
+#define GLMOLECULEVIEW_HPP_
+
+#include <QtOpenGL/QGLWidget>
+
+class GLMoleculeView :  public QGLWidget
+{
+  Q_OBJECT
+public:
+  GLMoleculeView(QWidget *parent=0);
+  virtual ~GLMoleculeView();
+};
+
+#endif /* GLMOLECULEVIEW_HPP_ */
Index: src/UIElements/Views/Qt4/QtMoleculeView.cpp
===================================================================
--- src/UIElements/Views/Qt4/QtMoleculeView.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/Views/Qt4/QtMoleculeView.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,106 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * QtMoleculeView.cpp
+ *
+ *  Created on: Mar 4, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Views/Qt4/QtMoleculeView.hpp"
+
+#include <iostream>
+
+#include "Helpers/MemDebug.hpp"
+
+#include "molecule.hpp"
+
+using namespace std;
+
+/***************** Basic structure for tab layout ***********/
+
+QtMoleculeView::QtMoleculeView() :
+    QTabWidget()
+{
+  allPage = new QTAllMoleculePage();
+  addTab(allPage,QString("All Molecules"));
+
+  connect(this,SIGNAL(addMolecule(molecule*)),allPage,SLOT(addMolecule(molecule*)));
+  connect(this,SIGNAL(removeMolecule(molecule*)),allPage,SLOT(removeMolecule(molecule*)));
+}
+
+QtMoleculeView::~QtMoleculeView()
+{}
+
+void QtMoleculeView::moleculeSelected(molecule *mol){
+  if(!pages.count(mol)){
+    string molName = mol->GetName();
+    QTMoleculePage *molPage = new QTMoleculePage(mol,molName);
+    addTab(molPage,QString(molName.c_str()));
+    pages[mol] = molPage;
+
+    connect(molPage,SIGNAL(nameChanged(QTMoleculePage*,std::string)),this,SLOT(nameChanged(QTMoleculePage*,std::string)));
+
+    emit addMolecule(mol);
+  }
+}
+
+void QtMoleculeView::moleculeUnSelected(molecule *mol){
+  if(pages.count(mol)){
+    QTMoleculePage *molPage = pages[mol];
+    removeTab(indexOf(molPage));
+    pages.erase(mol);
+    delete molPage;
+    emit removeMolecule(mol);
+  }
+}
+
+void QtMoleculeView::nameChanged(QTMoleculePage *page, std::string name){
+  setTabText(indexOf(page),QString(name.c_str()));
+}
+
+/************************ Tab for all Molecules ********************/
+
+QTAllMoleculePage::QTAllMoleculePage() :
+  Observer("QTAllMoleculePage")
+{}
+
+void QTAllMoleculePage::addMolecule(molecule *mol){}
+
+void QTAllMoleculePage::removeMolecule(molecule *mol){}
+
+void QTAllMoleculePage::update(Observable *subject){}
+
+void QTAllMoleculePage::subjectKilled(Observable *subject){}
+
+/************************ Tab for single Molecules *****************/
+
+QTMoleculePage::QTMoleculePage(molecule *_mol, string _name) :
+    Observer("QTMoleculePage"),
+    mol(_mol), name(_name)
+{
+  mol->signOn(this);
+}
+
+QTMoleculePage::~QTMoleculePage(){
+  mol->signOff(this);
+}
+
+void QTMoleculePage::update(Observable *subject){
+  if(name != mol->GetName()){
+    name = mol->GetName();
+    emit nameChanged(this,name);
+  }
+}
+
+void QTMoleculePage::subjectKilled(Observable *subject){}
Index: src/UIElements/Views/Qt4/QtMoleculeView.hpp
===================================================================
--- src/UIElements/Views/Qt4/QtMoleculeView.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/Views/Qt4/QtMoleculeView.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,77 @@
+/*
+ * MoleculeView.hpp
+ *
+ *  Created on: Mar 4, 2010
+ *      Author: crueger
+ */
+
+#ifndef MOLECULEVIEW_HPP_
+#define MOLECULEVIEW_HPP_
+
+#include <string>
+#include <QtGui/QTabWidget>
+#include "Patterns/Observer.hpp"
+
+class molecule;
+
+// Forwarding of the Tab-Pages
+class QTAllMoleculePage;
+class QTMoleculePage;
+
+class QtMoleculeView : public QTabWidget
+{
+  Q_OBJECT
+public:
+  QtMoleculeView();
+  virtual ~QtMoleculeView();
+
+public slots:
+  void moleculeSelected(molecule *);
+  void moleculeUnSelected(molecule *);
+
+  void nameChanged(QTMoleculePage *page, std::string name);
+
+signals:
+  void addMolecule(molecule *);
+  void removeMolecule(molecule *);
+
+
+private:
+  QTAllMoleculePage *allPage; //!< contained widget to cary information of all selected molecules
+  std::map<molecule*,QTMoleculePage *> pages;//!< contained widget to cary information on a specific molecule
+};
+
+/**
+ * Widget to display the tab page for all selected molecules
+ */
+class QTAllMoleculePage : public QWidget, public Observer {
+  Q_OBJECT
+public:
+  QTAllMoleculePage();
+  void update(Observable *subject);
+  void subjectKilled(Observable *subject);
+public slots:
+  void addMolecule(molecule *mol);
+  void removeMolecule(molecule *mol);
+};
+
+/**
+ * Widget to display the tab page for a single molecule
+ */
+class QTMoleculePage : public QWidget,  public Observer {
+  Q_OBJECT
+public:
+  QTMoleculePage(molecule *_mol,std::string _name);
+  virtual ~QTMoleculePage();
+
+  void update(Observable *subject);
+  void subjectKilled(Observable *subject);
+
+signals:
+  void nameChanged(QTMoleculePage*,std::string);
+
+private:
+  molecule *mol;
+  std::string name;
+};
+#endif /* MOLECULEVIEW_HPP_ */
Index: src/UIElements/Views/Qt4/QtStatusBar.cpp
===================================================================
--- src/UIElements/Views/Qt4/QtStatusBar.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/Views/Qt4/QtStatusBar.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,128 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * QtStatusBar.cpp
+ *
+ *  Created on: Feb 17, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <sstream>
+
+#include <QtGui/QLabel>
+#include <QtGui/QBoxLayout>
+#include <QtGui/QProgressBar>
+
+#include "QtStatusBar.hpp"
+
+#include "Helpers/MemDebug.hpp"
+
+#include "World.hpp"
+#include "Helpers/helpers.hpp"
+#include "Actions/Process.hpp"
+
+
+QtStatusBar::QtStatusBar(QWidget *_parent) :
+  QStatusBar(_parent),
+  Observer("QtStatusBar"),
+  atomCount(World::getInstance().numAtoms()),
+  moleculeCount(World::getInstance().numMolecules()),
+  parent(_parent)
+{
+  World::getInstance().signOn(this);
+  Process::AddObserver(this);
+  statusLabel = new QLabel(this);
+  statusLabel->setFrameStyle(QFrame::NoFrame | QFrame::Plain);
+  addPermanentWidget(statusLabel);
+  redrawStatus();
+}
+
+QtStatusBar::~QtStatusBar()
+{
+  Process::RemoveObserver(this);
+  World::getInstance().signOff(this);
+}
+
+void QtStatusBar::update(Observable *subject){
+  if (subject==World::getPointer()){
+    atomCount = World::getInstance().numAtoms();
+    moleculeCount = World::getInstance().numMolecules();
+    redrawStatus();
+  }
+  else {
+    // we probably have some process
+    Process *proc;
+    if((proc=dynamic_cast<Process*>(subject))){
+      redrawProcess(proc);
+    }
+  }
+}
+
+void QtStatusBar::subjectKilled(Observable *subject){
+  // Processes don't notify when they are killed
+  atomCount = World::getInstance().numAtoms();
+  moleculeCount = World::getInstance().numMolecules();
+  World::getInstance().signOn(this);
+  redrawStatus();
+}
+
+void QtStatusBar::redrawStatus(){
+  stringstream sstr;
+  sstr << "You have " << atomCount << " atom" << PLURAL_S(atomCount)
+       <<" in " << moleculeCount << " molecule" << PLURAL_S(moleculeCount);
+  statusLabel->setText(QString(sstr.str().c_str()));
+}
+
+void QtStatusBar::redrawProcess(Process *proc){
+  progressIndicator *ind=0;
+  // see what we have to do with the process
+  if(proc->doesStart()){
+    ind = new progressIndicator(proc->getName());
+    ind->bar->setMaximum(proc->getMaxSteps());
+    progressBars.insert(pair<Process*,progressIndicator*>(proc,ind));
+  }
+  else {
+    ind = progressBars[proc];
+  }
+  if(activeProcess!=proc){
+    addWidget(ind->container);
+    activeProcess = proc;
+  }
+  ind->bar->setValue(proc->getCurrStep());
+  parent->repaint();
+  if(proc->doesStop()){
+    removeWidget(ind->container);
+    activeProcess = 0;
+    progressBars.erase(proc);
+    delete ind;
+  }
+}
+
+
+
+QtStatusBar::progressIndicator::progressIndicator(string name){
+  stringstream sstr;
+  sstr << "Busy (" << name << ")";
+  container = new QWidget();
+  layout = new QHBoxLayout(container);
+  label = new QLabel(QString(sstr.str().c_str()));
+  bar = new QProgressBar();
+
+  layout->addWidget(label);
+  layout->addWidget(bar);
+  container->setLayout(layout);
+}
+
+QtStatusBar::progressIndicator::~progressIndicator(){
+  delete container;
+}
Index: src/UIElements/Views/Qt4/QtStatusBar.hpp
===================================================================
--- src/UIElements/Views/Qt4/QtStatusBar.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/Views/Qt4/QtStatusBar.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,55 @@
+/*
+ * QtStatusBar.hpp
+ *
+ *  Created on: Feb 17, 2010
+ *      Author: crueger
+ */
+
+#ifndef QTSTATUSBAR_HPP_
+#define QTSTATUSBAR_HPP_
+
+#include <map>
+#include <utility>
+#include <string>
+#include <QtGui/QStatusBar>
+
+#include "Patterns/Observer.hpp"
+
+class QLabel;
+class QProgressBar;
+class Process;
+class QBoxLayout;
+
+class QtStatusBar : public QStatusBar, public Observer
+{
+  Q_OBJECT
+
+  struct progressIndicator{
+    progressIndicator(std::string);
+    ~progressIndicator();
+    QLabel *label;
+    QProgressBar *bar;
+    QBoxLayout *layout;
+    QWidget *container;
+  };
+public:
+  QtStatusBar(QWidget *parent=0);
+  virtual ~QtStatusBar();
+
+  void update(Observable *subject);
+  void subjectKilled(Observable *subject);
+
+private:
+  void redrawStatus();
+  void redrawProcess(Process *proc);
+
+  int atomCount;
+  int moleculeCount;
+
+  QLabel *statusLabel;
+  QWidget *parent;
+  std::map<Process*,progressIndicator*> progressBars;
+  Process* activeProcess;
+};
+
+#endif /* QTSTATUSBAR_HPP_ */
